/*
 *
 * InfoServiceRGMA.h
 *
 * Copyright (c) 2002 INFN, CERN on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or 
 * http://www.edg.org/license.html
 * 
 */

#ifndef EDGReplicaManager_InfoServiceRGMA_H
#define EDGReplicaManager_InfoServiceRGMA_H 1

#ifndef EDG_RM_NO_RGMA

/*
 * @author <a href="mailto:Peter.Kunszt@cern.ch">Peter Kunszt</a>
 */

#include "EdgReplicaManager/InfoService.h"

namespace EdgReplicaManager {

    //! RGMA interface
    class InfoServiceRGMA : public InfoService {
    public:

	/** Constructor
	 */

	InfoServiceRGMA(const std::string& vo, bool secure, const std::string& timeout );

	/** Destructor
	 */
        ~InfoServiceRGMA() {}

	//! get service
        const std::vector<std::string>& getServiceURIs(const std::string &serviceType, 
						       const std::string &domain) 
	    throw(InfoServiceException);

	//! get close SE based on a CE id
	std::string getCloseSE(const std::string& ceID) throw ( InfoServiceException );

    private:

	const std::vector<std::string>& query(const std::string& selectst) throw ( InfoServiceException );

	double m_timeout;
	std::vector<std::string> m_buffer;

    };

};

#endif
#endif
