/*
 *
 * InfoServiceStub.h
 *
 * Copyright (c) 2002 INFN, CERN on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or 
 * http://www.edg.org/license.html
 * 
 */

#ifndef EDGReplicaManager_InfoServiceStub_H
#define EDGReplicaManager_InfoServiceStub_H 1

/*
 * @author <a href="mailto:Peter.Kunszt@cern.ch">Peter Kunszt</a>
 */

#include "EdgReplicaManager/InfoService.h"
#include "EdgReplicaManager/Configuration.h"

namespace EdgReplicaManager {

    //! Info service based on a file
    class InfoServiceStub : public InfoService {
    public:

	/** Constructor
	 */

	InfoServiceStub(const std::string &vo, bool secure, const std::string &file )  throw ( ReplicaManagerException );

	/** Destructor
	 */
        ~InfoServiceStub();

	//! get service
        const std::vector<std::string>& getServiceURIs(const std::string &serviceType, 
						       const std::string &domain) 
	    throw(InfoServiceException) ;

	//! get close SE based on a CE id
        std::string getCloseSE(const std::string& ceID) throw ( InfoServiceException ) ;

    private:
	std::string replaceColon(const std::string& s);

	std::string m_file;
	std::vector<std::string> m_buffer;
	Configuration* m_stub;

    };

};

#endif
