// this is an example
// how to implement a listBestFile
// executable.


#include "EdgReplicaManager/ReplicaManagerImpl.h"
#include "EdgReplicaManager/Configuration.h"
#include "EdgReplicaManager/ReplicaManagerExceptions.h"
#include <iostream>

int main(int argc, char *argv[] ) {

    if( argc != 4 ) {
	std::cout << "Usage: " << argv[0] << " vo configfile lfn/guid " << std::endl;
	return -1;
    }

    /*
    const std::string initFileName = "config/log4cpp.properties";
    try {
	log4cpp::PropertyConfigurator::configure(initFileName);
    } catch(log4cpp::ConfigureFailure& f) {
	std::cout << "Log4cpp Configure Problem " << f.what() << std::endl;
	return -1;
    }
    */

    try {
    //     "http://lxshare0343.cern.ch:8080/edg-replica-optimization/services/edg-replica-optimization",
    //     "http://lxshare0344.cern.ch:8080/edg-replica-location/services/edg-local-replica-catalog",
    //     "http://lxshare0342.cern.ch:8080/edg-replica-metadata-catalog/services/edg-replica-metadata-catalog");

	std::string vo = argv[1];
	std::string conf = argv[2];
	std::string lfn = argv[3];
	std::vector<std::string> replicas;
	EdgReplicaManager::Configuration config(conf);
	EdgReplicaManager::ReplicaManagerImpl rm(vo,&config);
	rm.listReplicas(lfn, replicas);

	for(std::vector<std::string>::const_iterator iter = replicas.begin() ; iter != replicas.end() ; iter++) 
	    std::cout << (*iter) << std::endl;
    } catch (EdgReplicaManager::ReplicaManagerException &x) {
	std::cout << "EdgReplicaManager::ReplicaManagerException" << x.what() << std::endl;
	return -1;
    } catch (EdgReplicaLocationService::NoSuchGuidException &x) {
	std::cout << "EdgReplicaLocationService::NoSuchGuidException" << x.what() << std::endl;
	return -1;
    } catch (EdgReplicaLocationService::NoSuchPfnException &x) {
	std::cout << "EdgReplicaLocationService::NoSuchPfnException" << x.what() << std::endl;
	return -1;
    } catch (EdgReplicaMetadataCatalog::NoSuchAliasException &x) {
	std::cout << "EdgReplicaMetadataCatalog::NoSuchAliasException" << x.what() << std::endl;
	return -1;
    } catch (EdgReplicaLocationService::CommunicationException &x) {
	std::cout << "EdgReplicaLocationService::CommunicationException" << x.what() << std::endl;
	return -1;
    } catch (EdgReplicaMetadataCatalog::CommunicationException &x) {
	std::cout << "EdgReplicaMetadataCatalog::CommunicationException" << x.what() << std::endl;
	return -1;
    } catch (...) {
	std::cout << "unknown exception caught" << std::endl;
	return -1;
    }

    return 0;
}
