/*
 *
 * testMDS.cpp
 * this is a test for the MDS re-start functionality
 *
 * Copyright (c) 2003 CERN on behalf of the EU DataGrid.
 * For license conditions see LICENSE file or 
 * http://www.edg.org/license.html
 * 
 */


/*
 * @author <a href="mailto:Peter.Kunszt@cern.ch">Peter Kunszt</a>
 */


#include "EdgReplicaManager/ReplicaManagerImpl.h"
#include "EdgReplicaManager/Configuration.h"
#include "EdgReplicaManager/InfoServiceMDS.h"
#include "EdgReplicaManager/ReplicaManagerExceptions.h"
#include <iostream>

int main(int argc, char *argv[] ) {

    if( argc != 4 ) {
	std::cout << "Usage: " << argv[0] << " vo mdsHost mdsPort" << std::endl;
	return -1;
    }

    std::string vo = argv[1];
    char mdsurl[200];
    sprintf(mdsurl,"ldap://%s:%s",argv[2],argv[3]);
    std::string host = mdsurl;
    std::string root = "mds-vo-name=local,o=grid";
    /*    try {

	EdgReplicaManager::ReplicaManagerImpl rm(vo);

	std::cout << "Replica Manager constructed o.k." << std::endl;

    } catch (EdgReplicaManager::ReplicaManagerException &x) {
	std::cout << "EdgReplicaManager::ReplicaManagerException" << x.what() << std::endl;
	return -1;
    } catch (...) {
	std::cout << "unknown exception caught" << std::endl;
	return -1;
    }
    */

    try {
	EdgReplicaManager::InfoServiceMDS info(vo,false,host,root);

	std::string cern = "cern.ch";
	std::cout << "LRC = " << info.getLocalReplicaCatalogLocation(cern) << std::endl;
	std::cout << "RMC = " << info.getMetadataCatalogLocation(cern) << std::endl;

    } catch (EdgReplicaManager::InfoServiceException &x) {
	std::cout << x.what() << std::endl;
	return -1;
    } catch (...) {
	std::cout << "unknown exception caught" << std::endl;
	return -1;
    }

    return 0;
}
